local index=...;
local i;
local t = Def.ActorFrame{
	InitCommand = function(self)
		if GAMESTATE:IsPlayerEnabled(PLAYER_1) and GAMESTATE:IsPlayerEnabled(PLAYER_2) then
			self:x(-120);
			self:rotationx(15);
			self:rotationy(35);
			self:zoom(0.9);
		elseif GAMESTATE:IsPlayerEnabled(PLAYER_2) then
			self:x(-SCREEN_CENTER_X/2);
			self:rotationy(-25);
			self:zoom(0.8);
		else
			self:rotationy(25);
		end;
	end;
	WheelUpdateCommand=function(self,params)
		local parent = self:GetParent()
		if params.Id ~= parent.Params.Id then return end
		self.Params = {Id = parent.Params.Id}
		
		i=index or params.DrawIndex;	-- [ja] index番号の取得 
		self:stoptweening();
	--[[
		楽曲の情報が入ったテーブル変数を取得します。
		これにより、以下の情報を取得することができます。
		GetSongWheel_Index(i)		ホイールの位置（中央が0）
		GetSongWheel_Song(i)		Song型
		GetSongWheel_Title(i)		曲名
		GetSongWheel_SubTitle(i)		サブタイトル
		GetSongWheel_Artist(i)		アーティスト名
		GetSongWheel_Graphic(i)		画像パス
		GetSongWheel_Color(i)		曲色
		GetSongWheel_MeterType(i)	難易度スケール（DDR / DDR X / ITG）
	--]]
		self:playcommand('WheelChildUpdate', params)
	end;
	LoadActor('_wheel song')..{
		InitCommand = function(self)
			self:x(0);
			self:faderight(0.9);
			self:effectclock('bgm');
			self:diffuseshift();
		end;
		WheelChildUpdateMessageCommand=function(self,params)
			local parent = self:GetParent()
			if params.Id ~= parent.Params.Id then return end
			if i==6 then
				local c = GetSongWheel_Color(i);
				self:effectcolor1(c[1], c[2], c[3], 0.75);
				self:effectcolor2(c[1], c[2], c[3], 0.5);
			else
				local c = GetSongWheel_Color(i);
				self:effectcolor1(c[1], c[2], c[3], 0.75);
				self:effectcolor2(c[1], c[2], c[3], 0.75);
			end;
		end;
	};
	--[[
	Def.Quad{
		InitCommand = function(self)
			self:x(0);
			self:y(0);
			self:zoomto(400,30);
			self:faderight(0.9);
			self:effectclock('bgm');
			self:diffuseshift();
		end;
		SetMessageCommand = function(self, params)
			if i==6 then
				local c = GetSongWheel_Color(i);
				self:effectcolor1(c[1], c[2], c[3], 0.75);
				self:effectcolor2(c[1], c[2], c[3], 0.5);
			else
				local c = GetSongWheel_Color(i);
				self:effectcolor1(c[1], c[2], c[3], 0.75);
				self:effectcolor2(c[1], c[2], c[3], 0.75);
			end;
		end;
	};
	--]]
	--[[
	ActorWheel() {	-- [ja] ホイール画像呼び出し用の関数です 
		--[ja] ジャケット表示
		SetMessageCommand=function(self,params)
			self:stoptweening();
			local song = GetSongWheel_Song(i);
			local g=GetSongWheel_Graphic(i);
			if song then
				if GetSongWheel_Index(i)==0 then
					self:visible(true);
					self:Load(g);
					self:stoptweening();
					self:rate(0.3);
					self:position(0);
					self:diffuseupperleft(1,1,1,1);
				else
					if g==song:GetBannerPath() then
						if self:LoadFromCachedBanner(g) then
							self:LoadFromCachedBanner(g);
						else
							self:Load(g);
						end;
					else
						self:Load(g);
					end;
					self:rate(1.0);
				end;
			else
				self:Load( THEME:GetPathG("Common fallback","jacket") );
			end;
			self:scaletofit(-35,-35,35,35);
			self:x(-160);
			self:y(0);
		end;
	};
	--]]
	LoadFont('common normal')..{
		InitCommand = function(self)
			self:x(-180);
			self:zoom(0.85);
			self:diffuse(Color('White'));
			self:strokecolor(Color('Outline'));
			self:horizalign(left);
			self:settext('');
		end;
		WheelChildUpdateMessageCommand=function(self,params)
			local parent = self:GetParent()
			if params.Id ~= parent.Params.Id then return end
			self:settext(GetSongWheel_Title(i));
		end;
	}
};
return t;